/**
 * Reprezentace neuronu
 * @author Martin Kot
 * @version 1.0 2001-05-11
 */

public class Neuron {
  /**Aktualni potencial neuronu*/
  private double potential;
  /**Vystup*/
  private double state;
  /**Chyba*/
  private double error;

  /**
   * Konstruktor
   */
  Neuron() {}

  /**
   * Inicializace neuronu.
   */
  public void initialize() {
    potential = 0;
    state = 0;
    error = 0;
  }
  
  /**
   * Slouzi k ziskani potencialu neuronu
   * @return potencial neuronu
   */
  public double getPotential() {
    return potential;
  }

  /**
   * Nuluje potencial
   */
  public void resetPotential() {
    potential = 0;
  }
  
  /**
   * Nastavi potencial. Slouzi pro nastaveni prvni vrstvy.
   */
  public void setPotential(double value) {
    potential = value;
  }

  /**
   * Zvetsi hodnotu potencialu
   * @param value Pricitana hodnota
   */
  public void adjustPotential(double value) {
    potential += value;
  }

  /**
   * Slouzi k ziskani vystupu neuronu
   * @return Vystupni stav neuronu
   */
  public double getState() {
    return state;
  }

  /**
   * Nastavi stav neuronu 
   * @param state Novy vystupni stav neuronu
   */
  public void setState(double state) {
    this.state = state;
  }

  /**
   * Slouzi k ziskani chyby neuronu
   * @return Chyba neuronu
   */
  double getError() {
    return error;
  }

  /**
   * Slouzi k nastaveni chyby neuronu
   * @param error Nova chyba neuronu
   */
  void setError(double error) {
    this.error = error;
  }

  /**
   * Slouzi k ziskani strmosti neuronu
   * @return Strmost 
   */
  double getSlope() {
    return NeuralNet.slope;
  }

  /**
   * Vypocita stav (vystup) neuronu podle potencialu
   */
  void transfer() {
    state=1/(1+( Math.exp((-1) * NeuralNet.slope * potential)));
  }
}
