import java.awt.*;
import java.awt.event.*;
import java.util.*;

/**
 * Trida okna pro zadavani parametru site
 * @author Martin Kot
 * @version 1.0 2001-05-16
 */
public class Parametry extends Frame {
  /**Odkaz na okno volajici tuto tridu. Je mu vraceno rizeni*/
  private GUI gui;
  /**Navesti pro konstantu koeficientu uceni*/
  private Label nyLabel = new Label();
  /**Pole pro konstantu koeficientu uceni*/
  private TextField nyField = new TextField();

  /**Navesti pro konstantu koeficientu zmeny vah*/
  private Label miLabel = new Label();
  /**Pole pro konstantu koeficientu zmeny vah*/
  private TextField miField = new TextField();
  
  /**Navesti pro konstantu maximalni tolerovane chyby*/
  private Label maxErrorLabel = new Label();
  /**Pole pro konstantu maximalni tolerovane chyby*/
  private TextField maxErrorField = new TextField();
  
  /**Navesti pro konstantu poctu opakovani trenovaci mnoziny*/
  private Label repSetLabel = new Label();
  /**Pole pro konstantu poctu opakovani trenovaci mnoziny*/
  private TextField repSetField = new TextField();
  
  /**Navesti pro konstantu poctu opakovani prvku trenovaci mnoziny*/
  private Label repItemLabel = new Label();
  /**Pole pro konstantu poctu opakovani prvku trenovaci mnoziny*/
  private TextField repItemField = new TextField();
  
  /**Navesti pro konstantu minimalni kladne hodnoty vahy*/
  private Label minWeightLabel = new Label();
  /**Pole pro konstantu minimalni kladne hodnoty vahy*/
  private TextField minWeightField = new TextField();
  
  /**Navesti pro konstantu maximalni kladne hodnoty vahy*/
  private Label maxWeightLabel = new Label();
  /**Pole pro konstantu maximalni kladne hodnoty vahy*/
  private TextField maxWeightField = new TextField();
  
  /**Navesti pro konstantu strmosti*/
  private Label slopeLabel = new Label();
  /**Pole pro konstantu strmosti*/
  private TextField slopeField = new TextField();
  
  /**Tlacitko pro potvrzeni zmen*/
  private Button okButton = new Button();
  /**Tlacitko pro konec okna bez ulozeni zmen*/
  private Button stornoButton = new Button();

  /**Slouzi k zobrazeni zprav uzivateli*/
  private Label messageLabel = new Label();

  /**
   * Konstruktor
   * @param gui Hlavni okno aplikace
   */
  public Parametry(GUI gui) {
    super("Parametry site");
    this.gui=gui;
    frameInit();
  }

  /**
   * Zobrazi chybovou hlasku uzivateli v prislusnem miste
   * @param s Zobrazovana hlaska
   */
  void showBadMsg(String s){
    this.messageLabel.setText(s);
    this.messageLabel.setForeground(Color.red);
  }
  
  /**
   * Zobrazi hlasku uzivateli v prislusnem miste
   * @param s Zobrazovana hlaska
   */
  void showGoodMsg(String s){
    this.messageLabel.setText(s);
    this.messageLabel.setForeground(Color.green);
  }

  /**
   * Znovu nacte hodnoty konstant a vyplni je do prislusnych poli
   */
  public void refresh() {
    showGoodMsg("");
    nyField.setText((new Double(NeuralNet.ny)).toString());
    miField.setText((new Double(NeuralNet.mi)).toString());
    maxErrorField.setText((new Double(NeuralNet.maxError)).toString());
    repItemField.setText((new Integer(NeuralNet.repItem)).toString());
    repSetField.setText((new Integer(NeuralNet.repSet)).toString());
    minWeightField.setText((new Double(NeuralNet.minWeight)).toString());
    maxWeightField.setText((new Double(NeuralNet.maxWeight)).toString());
    slopeField.setText((new Double(NeuralNet.slope)).toString());
  }
  

  /**
   * Inicializace okna. Nastavi parametry vsech prvku.
   */
  private void frameInit() {
    this.setLayout(null);
    
    nyLabel.setText("Koeficient uceni: ");
    nyLabel.setBounds(new Rectangle(10, 40, 200, 25));
    nyField.setBounds(new Rectangle(210, 40, 100, 25));
    this.add(nyField, null);
    this.add(nyLabel, null);

    miLabel.setText("Koef. vlivu zmeny: ");
    miLabel.setBounds(new Rectangle(10, 70, 200, 25));
    miField.setBounds(new Rectangle(210, 70, 100, 25));
    this.add(miField, null);
    this.add(miLabel, null);

    maxErrorLabel.setText("Maximalni chyba");
    maxErrorLabel.setBounds(new Rectangle(10, 100, 200, 25));
    maxErrorField.setBounds(new Rectangle(210, 100, 100, 25));
    this.add(maxErrorField, null);
    this.add(maxErrorLabel, null);

    repItemLabel.setText("Opakovani polozky");
    repItemLabel.setBounds(new Rectangle(10, 130, 200, 25));
    repItemField.setBounds(new Rectangle(210, 130, 100, 25));
    this.add(repItemField, null);
    this.add(repItemLabel, null);

    repSetLabel.setText("Opakovani mnoziny");
    repSetLabel.setBounds(new Rectangle(10, 160, 200, 25));
    repSetField.setBounds(new Rectangle(210, 160, 100, 25));
    this.add(repSetField, null);
    this.add(repSetLabel, null);

    minWeightLabel.setText("Min. kladna vaha: ");
    minWeightLabel.setBounds(new Rectangle(10, 190, 200, 25));
    minWeightField.setBounds(new Rectangle(210, 190, 100, 25));
    this.add(minWeightField, null);
    this.add(minWeightLabel, null);

    maxWeightLabel.setText("Max. kladna vaha: ");
    maxWeightLabel.setBounds(new Rectangle(10, 220, 200, 25));
    maxWeightField.setBounds(new Rectangle(210, 220, 100, 25));
    this.add(maxWeightField, null);
    this.add(maxWeightLabel, null);

    slopeLabel.setText("Strmost");
    slopeLabel.setBounds(new Rectangle(10, 250, 200, 25));
    slopeField.setBounds(new Rectangle(210, 250, 100, 25));
    this.add(slopeField, null);
    this.add(slopeLabel, null);

    okButton.setBounds(new Rectangle(20, 280, 130, 25));
    okButton.setLabel("OK");
    okButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        if(okButtonAction(e)){
	  gui.show();
	  hide();
	}
	else {
	  showBadMsg("Spatne zadana hodnota");
	}
      }
    });

    stornoButton.setBounds(new Rectangle(170, 280, 130, 25));
    stornoButton.setLabel("Storno");
    stornoButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
	  gui.show();
	  hide();
      }
    });
    
    messageLabel.setBounds(new Rectangle(10, 310, 300, 25));

    this.setResizable(false);
    this.addWindowListener(new java.awt.event.WindowAdapter() {
      public void windowClosing(WindowEvent e) {
	  gui.show();
	  hide();
      }
    });
    
    this.setBounds(new Rectangle(100, 100, 320, 360));
    this.add(okButton, null);
    this.add(stornoButton, null);
    this.add(messageLabel, null);
   }

  /**
   * Akce pri stisku tlacitka OK. Pokud jsou vsechny vstupny spravne vyplneny, 
   * nastavi je do NeuralNet a vrati true. Jinak necha hodnoty v NeuralNet bez
   * zmeny a vrati false
   * @return true pri spravnych hodnotach, false jinak
   */
  boolean okButtonAction(ActionEvent e) {
    double ny;
    double mi;
    double maxError;
    int repSet;
    int repItem;
    double slope;
    double maxWeight;
    double minWeight;
    try{
      ny=(new Double(nyField.getText())).doubleValue();
    }
    catch (NumberFormatException e8){
      nyField.requestFocus();
      return false;
    }
    try{
      mi=(new Double(miField.getText())).doubleValue();
    }
    catch (NumberFormatException e1){
      miField.requestFocus();
      return false;
    }
    try{
      maxError=(new Double(maxErrorField.getText())).doubleValue();
    }
    catch (NumberFormatException e2){
      maxErrorField.requestFocus();
      return false;
    }
    try{
      repSet=(new Integer(repSetField.getText())).intValue();
    }
    catch (NumberFormatException e3){
      repSetField.requestFocus();
      return false;
    }
    try{
      repItem=(new Integer(repItemField.getText())).intValue();
    }
    catch (NumberFormatException e4){
      repItemField.requestFocus();
      return false;
    }
    try{
      minWeight=(new Double(minWeightField.getText())).doubleValue();
    }
    catch (NumberFormatException e5){
      minWeightField.requestFocus();
      return false;
    }
    try{
      maxWeight=(new Double(maxWeightField.getText())).doubleValue();
    }
    catch (NumberFormatException e6){
      maxWeightField.requestFocus();
      return false;
    }
    try{
      slope=(new Double(slopeField.getText())).doubleValue();
    }
    catch (NumberFormatException e7){
      slopeField.requestFocus();
      return false;
    }
    NeuralNet.ny=ny;
    NeuralNet.mi=mi;
    NeuralNet.maxError=maxError;
    NeuralNet.repSet=repSet;
    NeuralNet.repItem=repItem;
    NeuralNet.minWeight=minWeight;
    NeuralNet.maxWeight=maxWeight;
    NeuralNet.slope=slope;
    return true;
  }
} 
